--[[

	SlammerBall v0.2
	____________________________________________
	Programming: MasterQ
	Graphics: MasterQ
	Sounds/Music: MasterQ
	Copyright  2005 MasterQ. All Rights Reserved.

]]

-- load images
background = Image.load("images/bg.png")
background1 = Image.load("images/bg1.png")
bgoverlay = Image.load("images/overlay.png")
ball = Image.load("images/ball.png")
target = Image.load("images/target.png")

-- define variables
config = {}
blue1 = Color.new(0, 102, 200)
blue2 = Color.new(0, 185, 250)
blue3 = Color.new(0, 66, 132)
wallcolor = Color.new(0, 66, 132)
doorcolor = Color.new(250, 140, 0)
white = Color.new(255, 255, 255)
targetpos = 1
lasttargetpos = 0
target_x = 7
target_y = 7
ball_x = 228
ball_y = 164
move_x = 0
move_y = 0
score = 0
door_pos1 = 0
door_pos2 = 55
door_dir = 0
bufferscore = 0
gameoversquare = 0
gameover_y = -143
gameover_speed = 27
levelcompletesquare = 0
levelcomplete_speed = 27
levelcomplete_y = -143
easyhighscore = 0
normalhighscore = 0
hardhighscore = 0
level = 1
bufferlevel = 1
menuitem = 0
menuchange = false
optionitem = 0
optionitemchange = false
screenid = 0
go = false
state = 0
musicon = 0
statechange = 0
bgmusic = "On"
difficulty = "Normal"
restart = false
gothighscore = false

-- load high scores
local e = assert(io.open("scores/score_easy.log", "r"))
easyhighscore = e:read("*number")
e:close()
local n = assert(io.open("scores/score_normal.log", "r"))
normalhighscore = n:read("*number")
n:close()
local h = assert(io.open("scores/score_hard.log", "r"))
hardhighscore = h:read("*number")
h:close()

-- Start USB Mode (makes it easier for me to quickly edit the script while it is open)
System.usbDiskModeActivate()

-- Load High Scores

-- check for buttons being pressed
function keyboardControl()
	screen.waitVblankStart()
	pad = Controls.read()
	if screenid == 0 then -- Main Menu
		if pad:up() then
			if menuchange == false then
				if menuitem > 0 then
					menuitem = menuitem - 1
					menuchange = true
				end
			end
		elseif pad:down() then
			if menuchange == false then
				if menuitem < 2 then
					menuitem = menuitem + 1
					menuchange = true
				end
			end
		elseif pad:cross() then
			go = true
		elseif pad:l() and pad:r() and pad:select() then -- End the script so it can be restarted (debugging purposes)
			restart = true 
		end
	elseif screenid == 1 then -- Game
		if pad:up() and state == 0 then
			if difficulty == "Easy" then
				move_x = 0
				move_y = -8
			elseif difficulty == "Normal" then
				move_x = 0
				move_y = -10
			elseif difficulty == "Hard" then
				move_x = 0
				move_y = -12
			end
		elseif pad:down() and state == 0 then
			if difficulty == "Easy" then
				move_x = 0
				move_y = 8
			elseif difficulty == "Normal" then
				move_x = 0
				move_y = 10
			elseif difficulty == "Hard" then
				move_x = 0
				move_y = 12
			end
		elseif pad:left() and state == 0 then
			if difficulty == "Easy" then
				move_x = -8
				move_y = 0
			elseif difficulty == "Normal" then
				move_x = -10
				move_y = 0
			elseif difficulty == "Hard" then
				move_x = -12
				move_y = 0
			end
		elseif pad:right() and state == 0 then
			if difficulty == "Easy" then
				move_x = 8
				move_y = 0
			elseif difficulty == "Normal" then
				move_x = 10
				move_y = 0
			elseif difficulty == "Hard" then
				move_x = 12
				move_y = 0
			end
		elseif pad:r() then
			newgame()
		elseif pad:l() then
			screenid = 0
			newgame()
		elseif pad:cross() and state == 2  then
			if statechange == 0 then
				if state == 2 then
					gameover_speed = 27
					state = 21
					statechange = 1
				end
			end
		elseif pad:cross() and state == 3  then
			if statechange == 0 then
				if state == 3 then
					levelcomplete_speed = 27
					state = 31
					statechange = 1
				end
			end
		elseif pad:start() then
			if statechange == 0 then
				if state == 0 then
					state = 1
					statechange = 1
				elseif state == 1 then
					state = 0
					statechange = 1
				end
			end
		end
	elseif screenid == 2 then --Options Screen
		if pad:up() then
			if optionitemchange == false then
				if optionitem > 0 then
					optionitem = optionitem - 1
					optionitemchange = true
				end
			end
		elseif pad:down() then
			if optionitemchange == false then
				if optionitem < 1 then
					optionitem = optionitem + 1
					optionitemchange = true
				end
			end
		elseif pad:right() then
			if optionitem == 0 then --Background Music
				if bgmusic == "Off" and optionitemchange == false then
					bgmusic = "On"
					optionitemchange = true
				elseif bgmusic == "On" and optionitemchange == false then
					bgmusic= "Off"
					optionitemchange = true
				end
			elseif optionitem == 1 then --Difficulty
				if difficulty == "Easy" and optionitemchange == false then
					difficulty = "Normal"
					optionitemchange = true
				elseif difficulty == "Normal" and optionitemchange == false then
					difficulty = "Hard"
					optionitemchange = true
				elseif difficulty == "Hard" and optionitemchange == false then
					difficulty = "Easy"
					optionitemchange = true
				end
			end
		elseif pad:left() then
			if optionitem == 0 then --Background Music
				if bgmusic == "Off" and optionitemchange == false then
					bgmusic = "On"
					optionitemchange = true
				elseif bgmusic == "On" and optionitemchange == false then
					bgmusic= "Off"
					optionitemchange = true
				end
			elseif optionitem == 1 then --Difficulty
				if difficulty == "Easy" and optionitemchange == false then
					difficulty = "Hard"
					optionitemchange = true
				elseif difficulty == "Hard" and optionitemchange == false then
					difficulty = "Normal"
					optionitemchange = true
				elseif difficulty == "Normal" and optionitemchange == false then
					difficulty = "Easy"
					optionitemchange = true
				end
			end
		elseif pad:circle() then
			screenid = 0
		end
	elseif screenid == 3 then --About Screen
		if pad:circle() then
			screenid = 0
		end
	end

end

-- set the new coordinates of the ball
function move()
	ball_x = ball_x + move_x
	ball_y = ball_y + move_y
end

-- start a new game
function newgame()
	level = 1
	move_x = 0
	move_y = 0
	ball_x = 228
	ball_y = 164
	settarget()
	gothighscore = false
	score = 0
	state = 0
end

-- draw the images on the screen
function drawgame()
	screen:blit(0, 0, background)
	screen:blit(target_x, target_y, target)
	screen:blit(ball_x, ball_y, ball)
	if level == 1 then
		screen:fillRect(215, 7, 5, 40, wallcolor) -- Line 1
		screen:fillRect(260, 7, 5, 40, wallcolor) -- Line 2
		screen:fillRect(57, 57, 50, 5, wallcolor) -- Line 3
		screen:fillRect(215, 42, 50, 5, wallcolor) -- Line 4
		screen:fillRect(373, 57, 50, 5, wallcolor) -- Line 5
		screen:fillRect(57, 57, 5, 40, wallcolor) -- Line 6
		screen:fillRect(102, 57, 5, 40, wallcolor) -- Line 7
		screen:fillRect(373, 57, 5, 40, wallcolor) -- Line 8
		screen:fillRect(418, 57, 5, 40, wallcolor) -- Line 9
		screen:fillRect(57, 92, 50, 5, wallcolor) -- Line 10
		screen:fillRect(215, 108, 50, 5, wallcolor) -- Line 11
		screen:fillRect(373, 92, 50, 5, wallcolor) -- Line 12
		screen:fillRect(215, 108, 5, 40, wallcolor) -- Line 13
		screen:fillRect(260, 108, 5, 40, wallcolor) -- Line 14
		screen:fillRect(57, 160, 50, 5, wallcolor) -- Line 15
		screen:fillRect(215, 143, 50, 5, wallcolor) -- Line 16
		screen:fillRect(373, 160, 50, 5, wallcolor) -- Line 17
		screen:fillRect(57, 160, 5, 40, wallcolor) -- Line 18
		screen:fillRect(102, 160, 5, 40, wallcolor) -- Line 19
		screen:fillRect(373, 160, 5, 40, wallcolor) -- Line 20
		screen:fillRect(418, 160, 5, 40, wallcolor) -- Line 21
		screen:fillRect(57, 195, 50, 5, wallcolor) -- Line 22
		screen:fillRect(215, 210, 50, 5, wallcolor) -- Line 23
		screen:fillRect(373, 195, 50, 5, wallcolor) -- Line 24
		screen:fillRect(215, 210, 5, 40, wallcolor) -- Line 25
		screen:fillRect(260, 210, 5, 40, wallcolor) -- Line 26
	elseif level == 2 then
		screen:fillRect(57, 57, 40, 5, wallcolor) -- Line 1
		screen:fillRect(57, 57, 5, 40, wallcolor) -- Line 2
		screen:fillRect(57, 160, 5, 40, wallcolor) -- Line 3
		screen:fillRect(57, 195, 40, 5, wallcolor) -- Line 4
		screen:fillRect(127, 107, 5, 43, wallcolor) -- Line 5
		screen:fillRect(348, 107, 5, 43, wallcolor) -- Line 6
		screen:fillRect(172, 57, 136, 5, wallcolor) -- Line 7
		screen:fillRect(172, 195, 136, 5, wallcolor) -- Line 8
		screen:fillRect(383, 57, 40, 5, wallcolor) -- Line 9
		screen:fillRect(418, 57, 5, 40, wallcolor) -- Line 10
		screen:fillRect(383, 195, 40, 5, wallcolor) -- Line 11
		screen:fillRect(418, 160, 5, 40, wallcolor) -- Line 12
		screen:fillRect(7, 92, 55, 5, wallcolor) -- Line 13
		screen:fillRect(92, 195, 5, 55, wallcolor) -- Line 14
		screen:fillRect(418, 160, 55, 5, wallcolor) -- Line 15
		screen:fillRect(383, 7, 5, 55, wallcolor) -- Line 16
	elseif level == 3 then
		screen:fillRect(92 - door_pos1, 133, 55, 5, doorcolor) -- Door 1
		screen:fillRect(157, 92 - door_pos2, 5, 55, doorcolor) -- Door 2
		screen:fillRect(317, 220 - door_pos2, 5, 55, doorcolor) -- Door 3
		screen:fillRect(332 + door_pos1, 133, 55, 5, doorcolor) -- Door 4
		screen:fillRect(7, 133, 30, 5, wallcolor) -- Line 1
		screen:fillRect(92, 133, 70, 5, wallcolor) -- Line 2
		screen:fillRect(157, 7, 5, 30, wallcolor) -- Line 3
		screen:fillRect(157, 92, 5, 158, wallcolor) -- Line 4
		screen:fillRect(317, 7, 5, 158, wallcolor) -- Line 5
		screen:fillRect(317, 220, 5, 30, wallcolor) -- Line 6
		screen:fillRect(317, 133, 70, 5, wallcolor) -- Line 7
		screen:fillRect(443, 133, 30, 5, wallcolor) -- Line 8
	end
	screen:blit(0, 0, bgoverlay)
	screen:print(6, 259, "Score: "..score, blue3)
	if difficulty == "Easy" then
		screen:print(110, 259, "High Score: "..easyhighscore, blue3)
	elseif difficulty == "Normal" then
		screen:print(110, 259, "High Score: "..normalhighscore, blue3)
	elseif difficulty == "Hard" then
		screen:print(110, 259, "High Score: "..hardhighscore, blue3)
	end
end

function gameover()
	if difficulty == "Easy" then
		if score > easyhighscore then
			gothighscore = true
			easyhighscore = score
			local e = assert(io.open("scores/score_easy.log", "w"))
			e:write(easyhighscore)
			e:close()
		end
	elseif difficulty == "Normal" then
		if score > normalhighscore then
			gothighscore = true
			normalhighscore = score
			local n = assert(io.open("scores/score_normal.log", "w"))
			n:write(normalhighscore)
			n:close()
		end
	elseif difficulty == "Hard" then
		if score > hardhighscore then
			gothighscore = true
			hardhighscore = score
			local h = assert(io.open("scores/score_hard.log", "w"))
			h:write(hardhighscore)
			h:close()
		end
	end
	bufferscore = score
	gameoversquare = 1
	statechange = 1
	state = 2
end

function collide(x1, y1, width1, height1, x2, y2, width2, height2)
	if x1 + width1 > x2 then
		if x1 < x2 + width2 then
			if y1 < y2 + height2 then
				if y1 + height1 > y2 then
					return true
				else
					return false
				end
			end
		end
	end
end

function checkcollisions()

	if level == 1 then

		-- Check if ball collides with Square1
		if collide(ball_x, ball_y, 24, 24, 215, 7, 50, 40) == true then
			gameover()
		end

		-- Check if ball collides with Square2
		if collide(ball_x, ball_y, 24, 24, 57, 57, 50, 40) == true then
			gameover()
		end

		-- Check if ball collides with Square3
		if collide(ball_x, ball_y, 24, 24, 373, 57, 50, 40) == true then
			gameover()
		end

		-- Check if ball collides with Square4
		if collide(ball_x, ball_y, 24, 24, 215, 108, 50, 40) == true then
			gameover()
		end

		-- Check if ball collides with Square5
		if collide(ball_x, ball_y, 24, 24, 57, 160, 50, 40) == true then
			gameover()
		end

		-- Check if ball collides with Square6
		if collide(ball_x, ball_y, 24, 24, 373, 160, 50, 40) == true then
			gameover()
		end

		-- Check if ball collides with Square7
		if collide(ball_x, ball_y, 24, 24, 215, 210, 50, 40) == true then
			gameover()
		end

	elseif level == 2 then

		-- Check if ball collides with Line1
		if collide(ball_x, ball_y, 24, 24, 57, 57, 40, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line2
		if collide(ball_x, ball_y, 24, 24, 57, 57, 5, 40) == true then
			gameover()
		end

		-- Check if ball collides with Line3
		if collide(ball_x, ball_y, 24, 24, 57, 160, 5, 40) == true then
			gameover()
		end

		-- Check if ball collides with Line4
		if collide(ball_x, ball_y, 24, 24, 57, 195, 40, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line5
		if collide(ball_x, ball_y, 24, 24, 127, 107, 5, 43) == true then
			gameover()
		end

		-- Check if ball collides with Line6
		if collide(ball_x, ball_y, 24, 24, 348, 107, 5, 43) == true then
			gameover()
		end

		-- Check if ball collides with Line7
		if collide(ball_x, ball_y, 24, 24, 172, 57, 136, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line8
		if collide(ball_x, ball_y, 24, 24, 172, 195, 136, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line9
		if collide(ball_x, ball_y, 24, 24, 383, 57, 40, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line10
		if collide(ball_x, ball_y, 24, 24, 418, 57, 5, 40) == true then
			gameover()
		end

		-- Check if ball collides with Line11
		if collide(ball_x, ball_y, 24, 24, 383, 195, 40, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line12
		if collide(ball_x, ball_y, 24, 24, 418, 160, 5, 40) == true then
			gameover()
		end

		-- Check if ball collides with Line13
		if collide(ball_x, ball_y, 24, 24, 7, 92, 55, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line14
		if collide(ball_x, ball_y, 24, 24, 92, 195, 5, 55) == true then
			gameover()
		end

		-- Check if ball collides with Line15
		if collide(ball_x, ball_y, 24, 24, 418, 160, 55, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line16
		if collide(ball_x, ball_y, 24, 24, 383, 7, 5, 55) == true then
			gameover()
		end
	elseif level ==3 then
		-- Check if ball collides with Line1
		if collide(ball_x, ball_y, 24, 24, 7, 133, 30, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line2
		if collide(ball_x, ball_y, 24, 24, 92, 133, 70, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line3
		if collide(ball_x, ball_y, 24, 24, 157, 7, 5, 30) == true then
			gameover()
		end

		-- Check if ball collides with Line4
		if collide(ball_x, ball_y, 24, 24, 157, 92, 5, 158) == true then
			gameover()
		end

		-- Check if ball collides with Line5
		if collide(ball_x, ball_y, 24, 24, 317, 7, 5, 158) == true then
			gameover()
		end

		-- Check if ball collides with Line6
		if collide(ball_x, ball_y, 24, 24, 317, 220, 5, 30) == true then
			gameover()
		end

		-- Check if ball collides with Line7
		if collide(ball_x, ball_y, 24, 24, 317, 133, 70, 5) == true then
			gameover()
		end

		-- Check if ball collides with Line8
		if collide(ball_x, ball_y, 24, 24, 443, 133, 30, 5) == true then
			gameover()
		end

		-- Check if ball collides with Door1
		if collide(ball_x, ball_y, 24, 24, 92 - door_pos1, 133, 55, 5) == true then
			gameover()
		end

		-- Check if ball collides with Door2
		if collide(ball_x, ball_y, 24, 24, 157, 92 - door_pos2, 5, 55) == true then
			gameover()
		end

		-- Check if ball collides with Door3
		if collide(ball_x, ball_y, 24, 24, 317, 220 - door_pos2, 5, 55) == true then
			gameover()
		end

		-- Check if ball collides with Door4
		if collide(ball_x, ball_y, 24, 24, 332 + door_pos1, 133, 55, 5) == true then
			gameover()
		end
	end
	if ball_y < 8 then -- Check if ball collides with Top Wall
		gameover()
	end
	
	if (ball_y + 24) > 250 then -- Check if ball collides with Bottom Wall
		gameover()
	end

	if ball_x < 8 then -- Check if ball collides with Left Wall
		gameover()
	end

	if (ball_x + 24) > 473 then -- Check if ball collides with Right Wall
		gameover()
	end

	-- Check if ball collides with Target
	if collide(ball_x, ball_y, 24, 24, target_x, target_y, 24, 24) == true then
		settarget()
		score = score + 5
		if score == 100 or score == 200 then
			bufferlevel = level
			state = 3
			levelcompletesquare = 1
		end
	end
end

function nextlevel()
	move_x = 0
	move_y = 0
	if level == 1 then
		level = 2
		ball_x = 228
		ball_y = 124
	elseif level ==2 then
		level = 3
		ball_x = 228
		ball_y = 124
	end
end

function settarget()
	math.randomseed(os.time())
	if level == 1 then
		while targetpos == lasttargetpos do
			targetpos = math.random(1, 7)
		end
		if targetpos == 1 then
			target_x = 20
			target_y= 19
			lasttargetpos = 1
		elseif targetpos == 2 then
			target_x = 433
			target_y= 19
			lasttargetpos = 2
		elseif targetpos == 3 then
			target_x = 20
			target_y= 218
			lasttargetpos = 3
		elseif targetpos == 4 then
			target_x = 433
			target_y= 218
			lasttargetpos = 4
		elseif targetpos == 5 then
			target_x = 181
			target_y= 116
			lasttargetpos = 5
		elseif targetpos == 6 then
			target_x = 275
			target_y= 116
			lasttargetpos = 6
		elseif targetpos == 7 then
			target_x = 228
			target_y= 74
			lasttargetpos = 7
		end
	elseif level ==2 then
		while targetpos == lasttargetpos do
			targetpos = math.random(1, 10)
		end
		if targetpos == 1 then
			target_x = 20
			target_y= 57
			lasttargetpos = 1
		elseif targetpos == 2 then
			target_x = 208
			target_y= 20
			lasttargetpos = 2
		elseif targetpos == 3 then
			target_x = 399
			target_y= 20
			lasttargetpos = 3
		elseif targetpos == 4 then
			target_x = 93
			target_y= 116
			lasttargetpos = 4
		elseif targetpos == 5 then
			target_x = 142
			target_y= 116
			lasttargetpos = 5
		elseif targetpos == 6 then
			target_x = 314
			target_y= 116
			lasttargetpos = 6
		elseif targetpos == 7 then
			target_x = 363
			target_y= 116
			lasttargetpos = 7
		elseif targetpos == 8 then
			target_x = 57
			target_y= 213
			lasttargetpos = 8
		elseif targetpos == 9 then
			target_x = 228
			target_y= 213
			lasttargetpos = 9
		elseif targetpos == 10 then
			target_x = 436
			target_y= 176
			lasttargetpos = 10
		end
	elseif level == 3 then
		while targetpos == lasttargetpos do
			targetpos = math.random(1, 5)
		end
		if targetpos == 1 then
			target_x = 17
			target_y= 17
			lasttargetpos = 1
		elseif targetpos == 2 then
			target_x = 122
			target_y= 215
			lasttargetpos = 2
		elseif targetpos == 3 then
			target_x = 227
			target_y= 123
			lasttargetpos = 3
		elseif targetpos == 4 then
			target_x = 332
			target_y= 17
			lasttargetpos = 4
		elseif targetpos == 5 then
			target_x = 438
			target_y= 215
			lasttargetpos = 5
		end
	end
end

function drawgameover()
	if gameover_y < 57 then
		gameover_y = gameover_y + gameover_speed
		gameover_speed = gameover_speed - 2
		if gameover_speed == 0 or gameover_speed < 0 then
			gameover_speed = 1
		end
	end
	if gameoversquare == 1 then
		screen:fillRect(127, gameover_y, 226, 143, white) -- Game Over Square
		screen:print(180, gameover_y + 5, "G A M E  O V E R", blue1)
		screen:print(210, gameover_y + 45, "Score: "..bufferscore, blue1)
		if gothighscore then
			screen:print(150, gameover_y + 85, "You Got the High Score!", blue1)
		end
		screen:print(160, gameover_y + 125, "Press X for New Game", blue1)
	end
end

function gameoverup()
	if gameover_y > -143 then
		gameover_y = gameover_y - gameover_speed
		gameover_speed = gameover_speed - 2
		if gameover_speed == 0 or gameover_speed < 0 then
			gameover_speed = 1
		end
	else
		newgame()
		state = 0
		statechange = 1
		gameoversquare = 0
		gameover_y = -143
		gameover_speed = 27
	end
	if gameoversquare == 1 then
		screen:fillRect(127, gameover_y, 226, 143, white) -- Game Over Square
		screen:print(180, gameover_y + 5, "G A M E  O V E R", blue1)
		screen:print(210, gameover_y + 45, "Score: "..bufferscore, blue1)
		if gothighscore then
			screen:print(150, gameover_y + 85, "You Got the High Score!", blue1)
		end
		screen:print(160, gameover_y + 125, "Press X for New Game", blue1)
	end
end

function drawlevelcomplete()
	if levelcomplete_y < 57 then
		levelcomplete_y = levelcomplete_y + levelcomplete_speed
		levelcomplete_speed = levelcomplete_speed - 2
		if levelcomplete_speed == 0 or levelcomplete_speed < 0 then
			levelcomplete_speed = 1
		end
	end
	if levelcompletesquare == 1 then
		screen:fillRect(127, levelcomplete_y, 226, 143, blue1) -- Level Complete Square
		screen:print(160, levelcomplete_y + 45, "You have successfully", white)
		screen:print(170, levelcomplete_y + 55, "completed Level "..bufferlevel.."!", white)
		screen:print(170, levelcomplete_y + 125, "Press X to Continue", white)
	end
end

function levelcompleteup()
	if levelcomplete_y > -143 then
		levelcomplete_y = levelcomplete_y - levelcomplete_speed
		levelcomplete_speed = levelcomplete_speed - 2
		if levelcomplete_speed == 0 or levelcomplete_speed < 0 then
			levelcomplete_speed = 1
		end
	else
		nextlevel()
		state = 0
		statechange = 1
		levelcompletesquare = 0
		levelcomplete_y = -143
		levelcomplete_speed = 27
	end
	if levelcompletesquare == 1 then
		screen:fillRect(127, levelcomplete_y, 226, 143, blue1) -- Level Complete Square
		screen:print(160, levelcomplete_y + 45, "You have successfully", white)
		screen:print(170, levelcomplete_y + 55, "completed Level "..bufferlevel.."!", white)
		screen:print(170, levelcomplete_y + 125, "Press X to Continue", white)
	end
end

-- main loop
while restart == false do

	if screenid == 0 then -- Main Menu
		if musicon == 1 then
			Music.stop()
			musicon = 0
		end
		for i=0,1 do
			keyboardControl()
		end
		screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
		if menuitem == 0 then
			screen:print(205, 100, "Start Game <", white)
			screen:print(215, 120, "Options", blue3)
			screen:print(223, 140, "About", blue3)
		elseif menuitem == 1 then
			screen:print(205, 100, "Start Game", blue3)
			screen:print(215, 120, "Options <", white)
			screen:print(223, 140, "About",blue3)
		elseif menuitem ==2 then
			screen:print(205, 100, "Start Game", blue3)
			screen:print(215, 120, "Options", blue3)
			screen:print(223, 140, "About <", white)
		end
		screen:print(10, 240, "v0.2", white)
		if go then
			if menuitem == 0 then
				go = false
				screenid = 1
				settarget()
			elseif menuitem == 1 then
				go = false
				optionitem = 0
				screenid = 2
			elseif menuitem == 2 then
				go = false
				screenid = 3
			end
		end
		screen.flip()
		screen.waitVblankStart(6)
		menuchange = false

	elseif screenid == 1  then -- Game
		if musicon == 0 and bgmusic == "On" then
			Music.playFile("sounds/music.xm", true)
			musicon = 1
		end

		if state == 0 then -- Game is in the Normal State
			for i=0,4 do
				keyboardControl()
			end
			move()
			if level == 3 then
				if door_pos1 == 55 then
					door_dir = 1
				elseif door_pos1 == 0 then
					door_dir = 0
				end
				if door_dir == 0 then
					door_pos1 = door_pos1 + 1
					door_pos2 = door_pos2 - 1
				else
					door_pos1 = door_pos1 - 1
					door_pos2 = door_pos2 + 1
				end
			end
			drawgame()
			checkcollisions()
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		elseif state == 1 then -- Game is in the Paused State
			for i=0,4 do
				keyboardControl()
			end
			drawgame()
			screen:print(380, 259, "P A U S E D", blue3)
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		elseif state == 2 then -- Game is in the Game Over State
			for i=0,4 do
				keyboardControl()
			end
			drawgame()
			drawgameover()
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		elseif state == 21 then -- Game is in the Level Complete Up State
			for i=0,4 do
				keyboardControl()
			end
			drawgame()
			gameoverup()
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		elseif state == 3 then -- Game is in the Level Complete State
			for i=0,4 do
				keyboardControl()
			end
			drawgame()
			drawlevelcomplete()
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		elseif state == 31 then -- Game is in the Level Complete Up State
			for i=0,4 do
				keyboardControl()
			end
			drawgame()
			levelcompleteup()
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		end

	elseif screenid == 2 then -- Options Screen
		for i=0,1 do
			keyboardControl()
		end
		screen:blit(0, 0, background1, 0, 0, background1:width(), background1:height(), false)
		screen:print(215, 10, "Options", white)
		screen:print(10, 20, "__________________________________________________________", blue3)
		if optionitem == 0 then
			screen:print(10, 30, "Background Music: "..bgmusic, white)
			screen:print(10, 40, "Difficulty: "..difficulty, blue3)
		elseif optionitem == 1 then
			screen:print(10, 30, "Background Music: "..bgmusic, blue3)
			screen:print(10, 40, "Difficulty: "..difficulty, white)
		end
		screen:print(10, 240, "Press O to return to the Main Menu.", white)
		screen.flip()
		screen.waitVblankStart(6)
		optionitemchange = false
		
	elseif screenid == 3 then -- About Screen

		for i=0,1 do
			keyboardControl()
		end
		screen:blit(0, 0, background1, 0, 0, background1:width(), background1:height(), false)
		screen:print(202, 10, "SlammerBall", white)
		screen:print(205, 20, "by MasterQ", white)
		screen:print(10, 30, "__________________________________________________________", blue3)
		screen:print(10, 40, "SlammerBall is based off of the PC game 'SlammerBall' made", white)
		screen:print(10, 50, "by me a few years ago. The PSP version was completely", white)
		screen:print(10, 60, "re-coded from scratch (not to mention in a different", white)
		screen:print(10, 70, "programming language).", white)
		screen:print(10, 90, "__________________________________________________________", blue3)
		screen:print(10, 103, "Instructions:", white)
		screen:print(10, 110, "__________________________________________________________", blue3)
		screen:print(10, 120, "You are the SlammerBall, and you have to collect the green", white)
		screen:print(10, 130, "targets while avoiding the outside walls and obstacles.", white)
		screen:print(10, 140, "Also, once you start moving, you can change directions,", white)
		screen:print(10, 150, "but you can't stop.", white)
		screen:print(10, 240, "Press O to return to the Main Menu.", white)
		screen.flip()

	end
end